const { options } = require("joi");
const dbSAPPS = require("../../helpers/db");
require("dotenv").config();
const { Op } = require("sequelize");

module.exports = {
	create,
	getAll,
	option,
	count,
	update,
	enabled,
	delete: _delete,
};

/**
 * Format an array of ages by appending a modifier field to each company.
 * The modifier field is the full name of the user who last modified the company.
 * @param {Object[]} ages - The array of ages to format.
 * @returns {Promise<Object[]>} - The formatted array of ages.
 */
const formatWithModifier = async (ages) => {
	return Promise.all(
		ages.map(async (age) => {
			const modifier = await dbSAPPS.User.findOne({
				where: {
					id: age.modified_by,
				},
				attributes: ["full_name"],
			});

			return {
				...age,
				modifier: modifier?.full_name,
			};
		})
	);
};

/**
 * Get all ages with their respective companies.
 * @param {Object} params - An object that contains parameters to filter the ages.
 * @param {Array} params.companiesId - Array of company IDs to filter by.
 * @returns {Promise<Object>} Resolves with an object that contains the ages and a success flag.
 * @example
 * const result = await getAll({ companiesId: [1, 2] });
 * console.log(result);
 */
async function getAll(params) {
	try {
		// filter
		const filterConditions = {};

		if (params.companiesId) {
			filterConditions.company_id = {
				[Op.in]: params.companiesId,
			};
		}

		let ages = [];
		ages = await dbSAPPS.Age.findAll({
			where: filterConditions,
			order: [["modified", "DESC"]],
			include: [
				{
					model: dbSAPPS.Company,
					as: "company",
					attributes: ["id", "display_name"],
				},
			],
		});

		ages = ages.map((age) => {
			return {
				...age.dataValues,
				company_name: age?.company?.display_name,
			};
		});

		ages = await formatWithModifier(ages);

		return {
			ages,
			success: true,
			message: "Loaded successfully!",
		};
	} catch (error) {
		const errorMessage = error?.message || "Failed to load, please try again!";
		return {
			success: false,
			message: errorMessage,
		};
	}
}

/**
 * Get ages with their respective settings.
 * @param {Object} params - An object that contains parameters to filter the ages.
 * @param {Array} params.companiesId - Array of company IDs to filter by.
 * @returns {Promise<Object>} Resolves with an object that contains the ages and a success flag.
 * @example
 * const result = await option({ companiesId: [1, 2] });
 * console.log(result);
 */
async function option(params) {
	try {
		// filter
		const filterConditions = {};

		if (params.company_id) {
			filterConditions.company_id = {
				[Op.eq]: params.company_id,
			};
		}

		if (params.companiesId) {
			filterConditions.company_id = {
				[Op.in]: params.companiesId,
			};
		}

		// must be enabled
		filterConditions.enabled = {
			[Op.eq]: true,
		};

		let options = [];
		options = await dbSAPPS.Age.findAll({
			where: filterConditions,
			attributes: [
				"id",
				"name",
				"display_name",
				"company_id",
				"age_min",
				"age_max",
			],
			include: [
				{
					model: dbSAPPS.Company,
					as: "company",
					attributes: ["id", "name", "display_name"],
				},
			],
			order: [["name", "ASC"]],
		});

		options = options.map((option) => {
			return {
				...option.dataValues,
				company_name: option?.company?.display_name,
			};
		});

		return {
			options,
			success: true,
			message: "Loaded successfully!",
		};
	} catch (error) {
		const errorMessage = error?.message || "Failed to load, please try again!";
		return {
			success: false,
			message: errorMessage,
		};
	}
}

/**
 * Count active ages
 *
 * @returns {Promise<{
 *   count: number,
 *   success: boolean,
 *   message: string
 * }>}
 */
async function count(params) {
	try {
		// filter
		const filterConditions = {};

		// must be enabled
		filterConditions.enabled = {
			[Op.eq]: true,
		};

		const count = await dbSAPPS.Age.count({
			where: filterConditions,
		});

		return {
			count,
			success: true,
			message: "Loaded successfully!",
		};
	} catch (error) {
		const errorMessage = error?.message || "Failed to load, please try again!";
		return {
			success: false,
			message: errorMessage,
		};
	}
}

/**
 * Creates a new age
 *
 * @param {object} params - age data to be created.
 * @param {string} params.name - age name.
 * @param {string} params.display_name - age display name.
 * @param {boolean} [params.enabled=true] - age enabled status.
 * @param {number} [params.creation=Date.now()] - age creation timestamp.
 * @param {number} [params.modified=Date.now()] - age last modification timestamp.
 * @param {number} [params.owner=1] - User ID of the age owner.
 * @param {number} [params.modified_by=1] - User ID of the last modifier of the age.
 *
 * @returns {Promise<{success: boolean, message: string}>} Result of the age creation process.
 */
async function create(params) {
	const transaction = await dbSAPPS.sequelize.transaction();
	try {
		// validate existing
		const existingName = await dbSAPPS.Age.findOne({
			where: { name: params.name, company_id: params.company_id },
			transaction,
		});
		if (existingName) {
			return {
				success: false,
				message: `"${params.name}" is already taken.`,
			};
		}

		const existingDisplayName = await dbSAPPS.Age.findOne({
			where: {
				display_name: params.display_name,
				company_id: params.company_id,
			},
			transaction,
		});
		if (existingDisplayName) {
			return {
				success: false,
				message: `"${params.display_name}" is already taken.`,
			};
		}

		// save
		await dbSAPPS.Age.create(params, { transaction });

		await transaction.commit();
		return {
			success: true,
			message: "Saved successfully!",
		};
	} catch (error) {
		await transaction.rollback();
		const errorMessage = error?.message || "Failed to save, please try again!";
		return {
			success: false,
			message: errorMessage,
		};
	}
}

/**
 * Updates an existing age
 *
 * @param {number} id - age ID to be updated.
 * @param {object} params - age data to be updated.
 * @param {string} [params.name] - age name.
 * @param {string} [params.display_name] - age display name.
 * @param {boolean} [params.enabled] - age enabled status.
 * @param {number} [params.creation] - age creation timestamp.
 * @param {number} [params.modified] - age last modification timestamp.
 * @param {number} [params.owner] - User ID of the age owner.
 * @param {number} [params.modified_by] - User ID of the last modifier of the age.
 *
 * @returns {Promise<{success: boolean, message: string}>} Result of the age update process.
 */
async function update(id, params) {
	const transaction = await dbSAPPS.sequelize.transaction();
	try {
		// validate existing
		const age = await dbSAPPS.Age.findByPk(id);
		if (!age) return { success: false, message: "ID not found!" };

		// validate existing
		const existingName = await dbSAPPS.Age.findOne({
			where: {
				name: params.name,
				company_id: params.company_id,
				id: {
					[Op.ne]: id,
				},
			},
			transaction,
		});
		if (existingName) {
			return {
				success: false,
				message: `"${params.name}" is already taken.`,
			};
		}

		const existingDisplayName = await dbSAPPS.Age.findOne({
			where: {
				display_name: params.display_name,
				company_id: params.company_id,
				id: {
					[Op.ne]: id,
				},
			},
			transaction,
		});
		if (existingDisplayName) {
			return {
				success: false,
				message: `"${params.display_name}" is already taken.`,
			};
		}

		// save
		await age.update(params, { transaction });

		await transaction.commit();
		return {
			success: true,
			message: "Saved successfully!",
		};
	} catch (error) {
		await transaction.rollback();
		const errorMessage = error?.message || "Failed to save, please try again!";
		return {
			success: false,
			message: errorMessage,
		};
	}
}

/**
 * Enable or disable a age
 * @param {number} id - the id of the age
 * @param {object} params - the update data
 * @param {boolean} params.enabled - the enabled status of the age
 * @param {number} [params.modified_by] - the modified by of the age
 * @param {Date} [params.modified] - the modified of the age
 * @returns {Promise<object>} - the result of the update
 */
async function enabled(id, params) {
	const transaction = await dbSAPPS.sequelize.transaction();
	try {
		// validate existing
		const age = await dbSAPPS.Age.findByPk(id);
		if (!age) return { success: false, message: "ID not found!" };

		// update params
		const updateData = {};
		updateData.enabled = params.enabled;
		if (params.modified_by) updateData.modified_by = params.modified_by;
		if (params.modified) updateData.modified = params.modified;

		// save
		await age.update(updateData, { transaction });

		await transaction.commit();
		return {
			success: true,
			message: "Saved successfully!",
		};
	} catch (error) {
		await transaction.rollback();
		const errorMessage = error?.message || "Failed to save, please try again!";
		return {
			success: false,
			message: errorMessage,
		};
	}
}

/**
 * Delete a age
 * @param {number} id - the id of the age
 * @returns {Promise<object>} - the result of the delete
 */
async function _delete(id) {
	const transaction = await dbSAPPS.sequelize.transaction();
	try {
		// validate existing
		const age = await dbSAPPS.Age.findByPk(id, { transaction });
		if (!age) return { success: false, message: "ID not found!" };

		// delete
		await age.destroy({ transaction });

		await transaction.commit();
		return {
			success: true,
			message: "Deleted successfully!",
		};
	} catch (error) {
		await transaction.rollback();
		const errorMessage =
			error?.message || "Failed to delete, please try again!";
		return {
			success: false,
			message: errorMessage,
		};
	}
}
